## vault 1.0.2+dfsg2

=== vendor/github.com/michaelklishin/rabbit-hole/Makefile ===
export GOPATH := $(CURDIR)

COVER_FILE := coverage

all: test

.PHONY: test

test: install-dependencies
	go test -race -v

cover: install-dependencies install-cover
	go test -v -test.coverprofile="$(COVER_FILE).prof"
	sed -i.bak 's|_'$(GOPATH)'|.|g' $(COVER_FILE).prof
	go tool cover -html=$(COVER_FILE).prof -o $(COVER_FILE).html
	rm $(COVER_FILE).prof*

install-cover:
	go get code.google.com/p/go.tools/cmd/cover

install-dependencies:
	go get github.com/onsi/ginkgo
	go get github.com/onsi/gomega
	go get github.com/streadway/amqp
        # to get Ginkgo CLI
	go install github.com/onsi/ginkgo/ginkgo

=== debian/changelog ===
vault (1.0.2+dfsg2-5) experimental; urgency=medium

  * Disables some unreliable tests and excluded "command" from testing.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 18 Mar 2020 16:10:31 +1100

vault (1.0.2+dfsg2-4) experimental; urgency=medium

  * Un-vendored "golang-github-oklog-run-dev".
  * New patch to fix FTBFS with "golang-google-api-dev (>= 0.15.0)"
    (Closes: #954187).
  * control: added "Pre-Depends: ${misc:Pre-Depends}".
  * Standards-Version: 4.5.0.
  * Rules-Requires-Root: no.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 18 Mar 2020 11:34:11 +1100

vault (1.0.2+dfsg2-3) experimental; urgency=medium

  * Un-vendored "golang-github-jackc-pgx-dev".

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 15 Jan 2020 20:54:21 +1100

vault (1.0.2+dfsg1-2) experimental; urgency=medium

  * DH to version 12
  * Standards-Version: 4.4.1
  * Build-Depends (un-vendored):
    + golang-github-google-go-github-dev
    + golang-github-hashicorp-go-plugin-dev

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 06 Jan 2020 15:18:38 +1100

vault (1.0.2+dfsg-1) experimental; urgency=medium

  * Initial release (Closes: #902677).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 30 Nov 2019 14:30:31 +1100

=== debian/control ===
Source: vault
Section: devel
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Build-Depends: debhelper-compat (= 12) ,bash-completion ,dh-golang (>= 1.39~) ,golang-any (>= 2:1.11~)
    ,golang-barcode-dev
    ,golang-etcd-server-dev
    ,golang-github-aliyun-aliyun-oss-go-sdk-dev
    ,golang-github-armon-go-metrics-dev
    ,golang-github-armon-go-proxyproto-dev
    ,golang-github-armon-go-radix-dev
    ,golang-github-asaskevich-govalidator-dev
    ,golang-github-azure-azure-sdk-for-go-dev (>= 10.3.0~)
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-azure-go-autorest-dev
    ,golang-github-bgentry-speakeasy-dev
    ,golang-github-cenkalti-backoff-dev
    ,golang-github-circonus-labs-circonus-gometrics-dev
    ,golang-github-circonus-labs-circonusllhist-dev
    ,golang-github-cockroachdb-cockroach-go-dev
    ,golang-github-coreos-go-oidc-dev
    ,golang-github-coreos-go-semver-dev
    ,golang-github-coreos-go-systemd-dev
    ,golang-github-coreos-pkg-dev
    ,golang-github-datadog-datadog-go-dev
    ,golang-github-denisenkom-go-mssqldb-dev
    ,golang-github-dgrijalva-jwt-go-dev
    ,golang-github-dustin-go-humanize-dev
    ,golang-github-elazarl-go-bindata-assetfs-dev
    ,golang-github-fatih-structs-dev
    ,golang-github-fsouza-go-dockerclient-dev (>= 0.0+git20160622~)
    ,golang-github-ghodss-yaml-dev
    ,golang-github-gocql-gocql-dev
    ,golang-github-go-errors-errors-dev
    ,golang-github-gogo-protobuf-dev (>= 1.2.1~)
    ,golang-github-golang-snappy-dev
    ,golang-github-go-ldap-ldap-dev (>= 2.5.1~)
    ,golang-github-googleapis-gax-go-dev
    ,golang-github-google-gofuzz-dev
    ,golang-github-go-test-deep-dev
    ,golang-github-google-go-github-dev (>= 28.1.1~)
    ,golang-github-google-go-querystring-dev
    ,golang-github-gorhill-cronexpr-dev
    ,golang-github-go-sql-driver-mysql-dev
    ,golang-github-hashicorp-consul-dev (>= 1.0.7~)
    ,golang-github-hashicorp-go-cleanhttp-dev
    ,golang-github-hashicorp-go-immutable-radix-dev
    ,golang-github-hashicorp-golang-lru-dev
    ,golang-github-hashicorp-go-memdb-dev
    ,golang-github-hashicorp-go-msgpack-dev
    ,golang-github-hashicorp-go-multierror-dev
    ,golang-github-hashicorp-nomad-dev
    ,golang-github-hashicorp-go-plugin-dev (>= 1.0.1~)
    ,golang-github-hashicorp-go-retryablehttp-dev (>= 0.6.3~)
    ,golang-github-hashicorp-go-rootcerts-dev
    ,golang-github-hashicorp-go-sockaddr-dev
    ,golang-github-hashicorp-go-syslog-dev
    ,golang-github-hashicorp-go-uuid-dev
    ,golang-github-hashicorp-go-version-dev
    ,golang-github-hashicorp-hcl-dev
    ,golang-github-hashicorp-memberlist-dev
    ,golang-github-hashicorp-serf-dev (>= 0.8.1~)
    ,golang-github-hashicorp-yamux-dev
    ,golang-github-influxdb-influxdb-dev
    ,golang-github-jackc-pgx-dev
    ,golang-github-jefferai-jsonx-dev
    ,golang-github-json-iterator-go-dev
    ,golang-github-kr-text-dev
    ,golang-github-lib-pq-dev
    ,golang-github-mattn-go-colorable-dev
    ,golang-github-mattn-go-isatty-dev
    ,golang-github-mgutz-ansi-dev
    ,golang-github-mitchellh-copystructure-dev
    ,golang-github-mitchellh-go-homedir-dev
    ,golang-github-mitchellh-go-testing-interface-dev
    ,golang-github-mitchellh-mapstructure-dev
    ,golang-github-mitchellh-reflectwalk-dev
    ,golang-github-ncw-swift-dev
    ,golang-github-nytimes-gziphandler-dev
    ,golang-github-oklog-run-dev
    ,golang-github-patrickmn-go-cache-dev
    ,golang-github-pborman-uuid-dev
    ,golang-github-pierrec-lz4-dev
    ,golang-github-pkg-errors-dev
    ,golang-github-posener-complete-dev
    ,golang-github-pquerna-cachecontrol-dev
    ,golang-github-pquerna-otp-dev
    ,golang-github-prometheus-common-dev
    ,golang-github-prometheus-client-golang-dev (>= 1.2.1~)
        ,golang-procfs-dev (>= 0.0.3~)
        ,golang-github-cespare-xxhash-dev (>= 2.1.0~)
    ,golang-github-ryanuber-columnize-dev (>= 2.1.0~)
    ,golang-github-ryanuber-go-glob-dev
    ,golang-github-samuel-go-zookeeper-dev
    ,golang-github-satori-go.uuid-dev
    ,golang-github-sirupsen-logrus-dev
    ,golang-github-spf13-pflag-dev
    ,golang-github-ugorji-go-codec
    ,golang-github-ugorji-go-codec-dev
    ,golang-glog-dev
    ,golang-golang-x-crypto-dev
    ,golang-golang-x-oauth2-dev (>= 0.0~git20180207~)
    ,golang-golang-x-sys-dev
    ,golang-golang-x-text-dev
    ,golang-golang-x-tools-dev
    ,golang-google-api-dev
    ,golang-google-appengine-dev
    ,golang-google-cloud-dev (>= 0.43.0~)
    ,golang-google-genproto-dev (>= 0.0~git20190801~)
    ,golang-go.opencensus-dev
    ,golang-gopkg-mgo.v2-dev
    ,golang-gopkg-square-go-jose.v2-dev
    ,golang-goprotobuf-dev
Standards-Version: 4.5.0
Homepage: https://www.vaultproject.io/
Vcs-Git: https://salsa.debian.org/go-team/packages/vault.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/vault
XS-Go-Import-Path: github.com/hashicorp/vault
Rules-Requires-Root: no

Package: vault
Architecture: any
Built-Using: ${misc:Built-Using}
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends} ,${misc:Depends}
    ,adduser
    ,pipexec
    ,procps
Recommends: ${misc:Recommends}
    ,consul
    ,libcap2-bin
Suggests: ${misc:Suggests}
Description: secrets and privileged access management, encryption as a service
 Vault secures, stores, and tightly controls access to tokens, passwords,
 certificates, API keys, and other secrets in modern computing. Vault
 handles leasing, key revocation, key rolling, and auditing. Through a
 unified API, users can access an encrypted Key/Value store and network
 encryption-as-a-service, or generate AWS IAM/STS credentials, SQL/NoSQL
 databases, X.509 certificates, SSH credentials, and more.
 .
 The key features of Vault are:
  * Secure Secret Storage: Arbitrary key/value secrets can be stored in
    Vault. Vault encrypts these secrets prior to writing them to persistent
    storage, so gaining access to the raw storage isn't enough to access
    your secrets. Vault can write to disk, Consul, and more.
 .
  * Dynamic Secrets: Vault can generate secrets on-demand for some systems,
    such as AWS or SQL databases. For example, when an application needs to
    access an S3 bucket, it asks Vault for credentials, and Vault will
    generate an AWS keypair with valid permissions on demand. After
    creating these dynamic secrets, Vault will also automatically revoke
    them after the lease is up.
 .
  * Data Encryption: Vault can encrypt and decrypt data without storing it.
    This allows security teams to define encryption parameters and
    developers to store encrypted data in a location such as SQL without
    having to design their own encryption methods.
 .
  * Leasing and Renewal: All secrets in Vault have a lease associated with
    it. At the end of the lease, Vault will automatically revoke that
    secret. Clients are able to renew leases via built-in renew APIs.
 .
  * Revocation: Vault has built-in support for secret revocation. Vault can
    revoke not only single secrets, but a tree of secrets, for example all
    secrets read by a specific user, or all secrets of a particular type.
    Revocation assists in key rolling as well as locking down systems in
    the case of an intrusion.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#export GOMAXPROCS=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_INSTALL_EXTRA := $(shell find -type d -name test-fixtures)

export DH_GOLANG_EXCLUDES = demo vault/external_tests

%:
	dh $@ --buildsystem=golang --with=golang,bash-completion --builddirectory=_build

override_dh_clean:
	dh_clean
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
#	-find . -type f -name '*.pb.go' -delete -printf 'removed %p\n'            ## delete generated .pb.go files
#	-find . -type f -name '*.generated.go' -print -delete ## delete .generated.go files
	-find vendor -type d -empty -delete -print

override_dh_auto_build:
## `go generate` sub-vendored component(s):
#	cd _build/src/github.com/hashicorp/vault/vendor/ \
#	&& GO111MODULE=off go generate -v -x ./...
#	
	dh_auto_build -v

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -v -p debian/tmp
	touch debian/tmp/.vault-token
	PATH="$(CURDIR)/_build/bin:$$PATH" \
        HOME="$(CURDIR)/debian/tmp" \
        DH_GOLANG_EXCLUDES="$(DH_GOLANG_EXCLUDES) api_test builtin/credential/cert command" \
        dh_auto_test -v --max-parallel=3 -- -short -failfast
endif

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_installsystemd:
	dh_installsystemd --no-enable
# --no-start

override_dh_installinit:
	dh_installinit --no-enable
#--no-start

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg2,\
repack,compression=xz,\
dversionmangle=s/[+~]dfsg\d*//,\
" https://github.com/hashicorp/vault/releases?after=sdk%2Fv0.1.8 \
  .*/archive/v?(\d[\d\.]+)\.tar\.gz

## vault 1.20.2

=== Makefile ===
# Determine this makefile's path.
# Be sure to place this BEFORE `include` directives, if any.
THIS_FILE := $(lastword $(MAKEFILE_LIST))

MAIN_PACKAGES=$$($(GO_CMD) list ./... | grep -v vendor/ )
SDK_PACKAGES=$$(cd $(CURDIR)/sdk && $(GO_CMD) list ./... | grep -v vendor/ )
API_PACKAGES=$$(cd $(CURDIR)/api && $(GO_CMD) list ./... | grep -v vendor/ )
ALL_PACKAGES=$(MAIN_PACKAGES) $(SDK_PACKAGES) $(API_PACKAGES)
TEST=$$(echo $(ALL_PACKAGES) | grep -v integ/ )
TEST_TIMEOUT?=45m
EXTENDED_TEST_TIMEOUT=60m
INTEG_TEST_TIMEOUT=120m
VETARGS?=-asmdecl -atomic -bool -buildtags -copylocks -methods -nilfunc -printf -rangeloops -shift -structtags -unsafeptr
GOFMT_FILES?=$$(find . -name '*.go' | grep -v pb.go | grep -v vendor)
SED?=$(shell command -v gsed || command -v sed)

GO_VERSION_MIN=$$(cat $(CURDIR)/.go-version)
GO_CMD?=go
CGO_ENABLED?=0
ifneq ($(FDB_ENABLED), )
	CGO_ENABLED=1
	BUILD_TAGS+=foundationdb
endif

# Set BUILD_MINIMAL to a non-empty value to build a minimal version of Vault with only core features.
BUILD_MINIMAL ?=
ifneq ($(strip $(BUILD_MINIMAL)),)
	BUILD_TAGS+=minimal
endif

default: dev

# bin generates the releasable binaries for Vault
bin: prep
	@CGO_ENABLED=$(CGO_ENABLED) BUILD_TAGS='$(BUILD_TAGS) ui' sh -c "'$(CURDIR)/scripts/build.sh'"

# dev creates binaries for testing Vault locally. These are put
# into ./bin/ as well as $GOPATH/bin
dev: BUILD_TAGS+=testonly
dev: prep
	@CGO_ENABLED=$(CGO_ENABLED) BUILD_TAGS='$(BUILD_TAGS)' VAULT_DEV_BUILD=1 sh -c "'$(CURDIR)/scripts/build.sh'"
dev-ui: BUILD_TAGS+=testonly
dev-ui: assetcheck prep
	@CGO_ENABLED=$(CGO_ENABLED) BUILD_TAGS='$(BUILD_TAGS) ui' VAULT_DEV_BUILD=1 sh -c "'$(CURDIR)/scripts/build.sh'"
dev-dynamic: BUILD_TAGS+=testonly
dev-dynamic: prep
	@CGO_ENABLED=1 BUILD_TAGS='$(BUILD_TAGS)' VAULT_DEV_BUILD=1 sh -c "'$(CURDIR)/scripts/build.sh'"

# quickdev creates binaries for testing Vault locally like dev, but skips
# the prep step.
quickdev: BUILD_TAGS+=testonly
quickdev:
	@CGO_ENABLED=$(CGO_ENABLED) BUILD_TAGS='$(BUILD_TAGS)' VAULT_DEV_BUILD=1 sh -c "'$(CURDIR)/scripts/build.sh'"

# *-mem variants will enable memory profiling which will write snapshots of heap usage
# to $TMP/vaultprof every 5 minutes. These can be analyzed using `$ go tool pprof <profile_file>`.
# Note that any build can have profiling added via: `$ BUILD_TAGS=memprofiler make ...`
dev-mem: BUILD_TAGS+=memprofiler
dev-mem: dev
dev-ui-mem: BUILD_TAGS+=memprofiler
dev-ui-mem: assetcheck dev-ui
dev-dynamic-mem: BUILD_TAGS+=memprofiler
dev-dynamic-mem: dev-dynamic

# Creates a Docker image by adding the compiled linux/amd64 binary found in ./bin.
# The resulting image is tagged "vault:dev".
docker-dev: BUILD_TAGS+=testonly
docker-dev: prep
	docker build --build-arg VERSION=$(GO_VERSION_MIN) --build-arg BUILD_TAGS="$(BUILD_TAGS)" -f scripts/docker/Dockerfile -t vault:dev .

docker-dev-ui: BUILD_TAGS+=testonly
docker-dev-ui: prep
	docker build --build-arg VERSION=$(GO_VERSION_MIN) --build-arg BUILD_TAGS="$(BUILD_TAGS)" -f scripts/docker/Dockerfile.ui -t vault:dev-ui .

# test runs the unit tests and vets the code
test: BUILD_TAGS+=testonly
test: prep
	@CGO_ENABLED=$(CGO_ENABLED) \
	VAULT_ADDR= \
	VAULT_TOKEN= \
	VAULT_DEV_ROOT_TOKEN_ID= \
	VAULT_ACC= \
	$(GO_CMD) test -tags='$(BUILD_TAGS)' $(TEST) $(TESTARGS) -timeout=$(TEST_TIMEOUT) -parallel=20

testcompile: BUILD_TAGS+=testonly
testcompile: prep
	@for pkg in $(TEST) ; do \
		$(GO_CMD) test -v -c -tags='$(BUILD_TAGS)' $$pkg -parallel=4 ; \
	done

# testacc runs acceptance tests
testacc: BUILD_TAGS+=testonly
testacc: prep
	@if [ "$(TEST)" = "./..." ]; then \
		echo "ERROR: Set TEST to a specific package"; \
		exit 1; \
	fi
	VAULT_ACC=1 $(GO_CMD) test -tags='$(BUILD_TAGS)' $(TEST) -v $(TESTARGS) -timeout=$(EXTENDED_TEST_TIMEOUT)

# testrace runs the race checker
testrace: BUILD_TAGS+=testonly
testrace: prep
	@CGO_ENABLED=1 \
	VAULT_ADDR= \
	VAULT_TOKEN= \
	VAULT_DEV_ROOT_TOKEN_ID= \
	VAULT_ACC= \
	$(GO_CMD) test -tags='$(BUILD_TAGS)' -race $(TEST) $(TESTARGS) -timeout=$(EXTENDED_TEST_TIMEOUT) -parallel=20

cover:
	./scripts/coverage.sh --html

# vet runs the Go source code static analysis tool `vet` to find
# any common errors.
vet:
	@$(GO_CMD) list -f '{{.Dir}}' ./... | grep -v /vendor/ \
		| grep -v '.*github.com/hashicorp/vault$$' \
		| xargs $(GO_CMD) vet ; if [ $$? -eq 1 ]; then \
			echo ""; \
			echo "Vet found suspicious constructs. Please check the reported constructs"; \
			echo "and fix them if necessary before submitting the code for reviewal."; \
		fi

# deprecations runs staticcheck tool to look for deprecations. Checks entire code to see if it
# has deprecated function, variable, constant or field
deprecations: bootstrap prep
	@BUILD_TAGS='$(BUILD_TAGS)' ./scripts/deprecations-checker.sh ""

# ci-deprecations runs staticcheck tool to look for deprecations. All output gets piped to revgrep
# which will only return an error if changes that is not on main has deprecated function, variable, constant or field
ci-deprecations: prep check-tools-external
	@BUILD_TAGS='$(BUILD_TAGS)' ./scripts/deprecations-checker.sh main

# vet-codechecker runs our custom linters on the test functions. All output gets
# piped to revgrep which will only return an error if new piece of code violates
# the check
vet-codechecker: check-tools-internal
	@echo "==> Running go vet with ./tools/codechecker..."
	@$(GO_CMD) vet -vettool=$$(which codechecker) -tags=$(BUILD_TAGS) ./... 2>&1 | revgrep

# vet-codechecker runs our custom linters on the test functions. All output gets
# piped to revgrep which will only return an error if new piece of code that is
# not on main violates the check
ci-vet-codechecker: tools-internal check-tools-external
	@echo "==> Running go vet with ./tools/codechecker..."
	@$(GO_CMD) vet -vettool=$$(which codechecker) -tags=$(BUILD_TAGS) ./... 2>&1 | revgrep origin/main

# lint runs vet plus a number of other checkers, it is more comprehensive, but louder
lint: check-tools-external
	@$(GO_CMD) list -f '{{.Dir}}' ./... | grep -v /vendor/ \
		| xargs golangci-lint run; if [ $$? -eq 1 ]; then \
			echo ""; \
			echo "Lint found suspicious constructs. Please check the reported constructs"; \
			echo "and fix them if necessary before submitting the code for reviewal."; \
		fi

# for ci jobs, runs lint against the changed packages in the commit
ci-lint: check-tools-external
	@golangci-lint run --deadline 10m --new-from-rev=HEAD~

# Lint protobuf files
protolint: prep check-tools-external
	@echo "==> Linting protobufs..."
	@buf lint

# prep runs `go generate` to build the dynamically generated
# source files.
#
# n.b.: prep used to depend on fmtcheck, but since fmtcheck is
# now run as a pre-commit hook (and there's little value in
# making every build run the formatter), we've removed that
# dependency.
prep: check-go-version clean
	@echo "==> Running go generate..."
	@GOARCH= GOOS= $(GO_CMD) generate $(MAIN_PACKAGES)
	@GOARCH= GOOS= cd api && $(GO_CMD) generate $(API_PACKAGES)
	@GOARCH= GOOS= cd sdk && $(GO_CMD) generate $(SDK_PACKAGES)

# Git doesn't allow us to store shared hooks in .git. Instead, we make sure they're up-to-date
# whenever a make target is invoked.
.PHONY: hooks
hooks:
	@if [ -d .git/hooks ]; then cp .hooks/* .git/hooks/; fi

-include hooks # Make sure they're always up-to-date

# bootstrap the build by generating any necessary code and downloading additional tools that may
# be used by devs.
bootstrap: tools prep

# Note: if you have plugins in GOPATH you can update all of them via something like:
# for i in $(ls | grep vault-plugin-); do cd $i; git remote update; git reset --hard origin/master; dep ensure -update; git add .; git commit; git push; cd ..; done
update-plugins:
	grep vault-plugin- go.mod | cut -d ' ' -f 1 | while read -r P; do echo "Updating $P..."; go get -v "$P"; done

static-assets-dir:
	@mkdir -p ./http/web_ui

install-ui-dependencies:
	@echo "==> Installing JavaScript assets"
	@cd ui && yarn

test-ember: install-ui-dependencies
	@echo "==> Running ember tests"
	@cd ui && yarn run test:oss

test-ember-enos: install-ui-dependencies
	@echo "==> Running ember tests with a real backend"
	@cd ui && yarn run test:enos

ember-dist: install-ui-dependencies
	@cd ui && npm rebuild node-sass
	@echo "==> Building Ember application"
	@cd ui && yarn run build
	@rm -rf ui/if-you-need-to-delete-this-open-an-issue-async-disk-cache

ember-dist-dev: install-ui-dependencies
	@cd ui && npm rebuild node-sass
	@echo "==> Building Ember application"
	@cd ui && yarn run build:dev

static-dist: ember-dist
static-dist-dev: ember-dist-dev

proto: check-tools-external
	@echo "==> Generating Go code from protobufs..."
	buf generate

	# No additional sed expressions should be added to this list. Going forward
	# we should just use the variable names chosen by protobuf. These are left
	# here for backwards compatibility, namely for SDK compilation.
	$(SED) -i -e 's/Id/ID/' -e 's/SPDX-License-IDentifier/SPDX-License-Identifier/' vault/request_forwarding_service.pb.go
	$(SED) -i -e 's/Idp/IDP/' -e 's/Url/URL/' -e 's/Id/ID/' -e 's/IDentity/Identity/' -e 's/EntityId/EntityID/' -e 's/Api/API/' -e 's/Qr/QR/' -e 's/Totp/TOTP/' -e 's/Mfa/MFA/' -e 's/Pingid/PingID/' -e 's/namespaceId/namespaceID/' -e 's/Ttl/TTL/' -e 's/BoundCidrs/BoundCIDRs/' -e 's/SPDX-License-IDentifier/SPDX-License-Identifier/' helper/identity/types.pb.go helper/identity/mfa/types.pb.go helper/storagepacker/types.pb.go sdk/plugin/pb/backend.pb.go sdk/logical/identity.pb.go vault/activity/activity_log.pb.go

	# This will inject the sentinel struct tags as decorated in the proto files.
	protoc-go-inject-tag -input=./helper/identity/types.pb.go
	protoc-go-inject-tag -input=./helper/identity/mfa/types.pb.go

importfmt: check-tools-external
	find . -name '*.go' | grep -v pb.go | grep -v vendor | xargs gosimports -w

fmt: importfmt
	find . -name '*.go' | grep -v pb.go | grep -v vendor | xargs gofumpt -w

fmtcheck: check-go-fmt

.PHONY: go-mod-download
go-mod-download:
	@$(CURDIR)/scripts/go-helper.sh mod-download

.PHONY: go-mod-tidy
go-mod-tidy:
	@$(CURDIR)/scripts/go-helper.sh mod-tidy

protofmt:
	buf format -w

semgrep:
	semgrep --include '*.go' --exclude 'vendor' -a -f tools/semgrep .

assetcheck:
	@echo "==> Checking compiled UI assets..."
	@sh -c "'$(CURDIR)/scripts/assetcheck.sh'"

spellcheck:
	@echo "==> Spell checking website..."
	@misspell -error -source=text website/source

.PHONY check-go-fmt:
check-go-fmt:
	@$(CURDIR)/scripts/go-helper.sh check-fmt

.PHONY check-go-version:
check-go-version:
	@$(CURDIR)/scripts/go-helper.sh check-version $(GO_VERSION_MIN)

.PHONY: check-proto-fmt
check-proto-fmt:
	buf format -d --error-format github-actions --exit-code

.PHONY: check-proto-delta
check-proto-delta: prep
	@echo "==> Checking for a delta in proto generated Go files..."
	@echo "==> Deleting all *.pg.go files..."
	find . -type f -name '*.pb.go' -delete -print0
	@$(MAKE) -f $(THIS_FILE) proto
	@if ! git diff --exit-code; then echo "Go protobuf bindings need to be regenerated. Run 'make proto' to fix them." && exit 1; fi

.PHONY:check-sempgrep
check-sempgrep: check-tools-external
	@echo "==> Checking semgrep..."
	@semgrep --error --include '*.go' --exclude 'vendor' -f tools/semgrep/ci .

.PHONY: check-tools
check-tools:
	@$(CURDIR)/tools/tools.sh check

.PHONY: check-tools-external
check-tools-external:
	@$(CURDIR)/tools/tools.sh check-external

.PHONY: check-tools-internal
check-tools-internal:
	@$(CURDIR)/tools/tools.sh check-internal

.PHONY: check-tools-pipeline
check-tools-pipeline:
	@$(CURDIR)/tools/tools.sh check-pipeline

check-vault-in-path:
	@VAULT_BIN=$$(command -v vault) || { echo "vault command not found"; exit 1; }; \
		[ -x "$$VAULT_BIN" ] || { echo "$$VAULT_BIN not executable"; exit 1; }; \
		printf "Using Vault at %s:\n\$$ vault version\n%s\n" "$$VAULT_BIN" "$$(vault version)"

.PHONY: tools
tools:
	@$(CURDIR)/tools/tools.sh install

.PHONY: tools-external
tools-external:

=== debian/changelog ===
vault (1.20.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.20.2 release
  * Bump the golang-go version required to build
  * Build with enumer 1.5.11

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sat, 09 Aug 2025 16:18:15 +0200

vault (1.18.3-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.18.3 release
  * Bump the golang-go version required to build

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Tue, 14 Jan 2025 14:49:52 +0200

vault (1.17.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.17.2 version
  * Drop the i386 build
  * Bump the required Go version to build Vault

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 24 Jul 2024 20:14:08 +0200

vault (1.16.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.16.2 version
  * Drop the remove-ci-bootstrap patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 08 May 2024 14:47:23 +0200

vault (1.15.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.15.1 version
  * Bump the golang-go version required

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Thu, 02 Nov 2023 16:05:14 +0100

vault (1.14.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.14.1 version
  * Remove golang-go as package dependancy
  * Update the conffile vault.env

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Mon, 07 Aug 2023 23:30:11 +0100

vault (1.12.6-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.12.6 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 10 Mar 2023 07:11:18 +0100

vault (1.12.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.12.2 version
  * Improve the packaging

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 02 Dec 2022 14:55:03 +0100

vault (1.12.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.12.1 version
  * Refresh the following quilt patches:
    - custom-yarn-for-build
    - kaisen-rules-for-build
  * Move the value of the GOPATH and GOBIN variable in _build
    instead of obj-x86_64-linux-gnu

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Thu, 03 Nov 2022 13:35:39 +0100

vault (1.11.3-1kaisen) kaisen-packages; urgency=medium

  * Import 1.11.3 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 25 Sep 2022 22:55:21 +0100

vault (1.11.2-1kaisen) kaisen-packages; urgency=medium

  * Import 1.11.2 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 14 Aug 2022 21:11:45 +0100

vault (1.11.0-1kaisen) kaisen-packages; urgency=medium

  * Import 1.11.0 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 08 Jul 2022 14:47:31 +0100

vault (1.10.4-1kaisen) kaisen-packages; urgency=medium

  * Import 1.10.4 version
  * Adding api_addr in the conffile
  * Update maintainers scripts to add the /srv/vault folder after the installation
    of the package and delete it when the package is purged

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Thu, 16 Jun 2022 05:56:17 +0100

vault (1.10.3-1kaisen) kaisen-packages; urgency=medium

  * Import 1.10.3 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 29 May 2022 23:56:32 +0100

vault (1.10.2-1kaisen) kaisen-packages; urgency=medium

  * Import 1.10.2 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Thu, 05 May 2022 23:10:58 +0100

vault (1.10.1-1kaisen) kaisen-packages; urgency=medium

  * Import 1.10.1 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sat, 23 Apr 2022 19:17:02 +0100

vault (1.10.0-3kaisen) kaisen-packages; urgency=medium

  * Improve a lot the packaging
  * Vault UI is now integrated in the builded binary
  * Added quilt patch to remove .git folder dependancies and yarn

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 15 Apr 2022 21:34:57 +0100

vault (1.10.0-2kaisen) kaisen-packages; urgency=medium

  * Added number version in the builded binary

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 15 Apr 2022 12:57:46 +0100

vault (1.10.0-1kaisen) kaisen-packages; urgency=medium

  * Import 1.10.0 release

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 30 Mar 2022 02:00:04 +0100

vault (1.9.4-1kaisen) kaisen-packages; urgency=medium

  * Import 1.9.4 version
  * Update vault logo

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 06 Mar 2022 17:27:29 +0100

vault (1.9.3-1kaisen) kaisen-packages; urgency=medium

  * First packaging for Kaisen Linux

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 13 Feb 2022 21:50:26 +0100

=== debian/control ===
Source: vault
Section: admin
Priority: optional
Maintainer: Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>
Build-Depends: debhelper-compat (= 13),
	       dh-golang,
	       golang-go (>= 1.24.4),
	       golang-golang-x-tools,
	       golang-github-enumer (>= 1.5.11-1kaisen),
	       gox (>= 1.0.1-1kaisen),
	       npm,
	       nodejs (<< 21), nodejs (>= 20),
Standards-Version: 4.7.2
Homepage: https://www.vaultproject.io/
Vcs-Browser: https://gitlab.com/kaisenlinux/packages/vault
Vcs-Git: https://gitlab.com/kaisenlinux/packages/vault.git
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/hashicorp/vault

Package: vault
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A tool for secrets management, encryption as a service, and privileged access management

=== debian/rules ===
#!/usr/bin/make -f

export GOPATH=$(CURDIR)/_build
export GOBIN=$(CURDIR)/_build/bin
export GO111MODULE=on
#export NODE_OPTIONS=--openssl-legacy-provider

%:
	dh $@ --buildsystem=golang --builddirectory=_build

override_dh_auto_clean:
	rm -rf $(CURDIR)/_build

override_dh_auto_build:
	#Install the latest yarn version in $GOPATH
	npm install --global yarn --prefix $(CURDIR)/_build
	#Building vault...
	make bootstrap
	make mysql-database-plugin
	make mysql-legacy-database-plugin
	make cassandra-database-plugin
	make influxdb-database-plugin
	make postgresql-database-plugin
	make mssql-database-plugin
	make hana-database-plugin
	make mongodb-database-plugin
	make static-dist
	make assetcheck
	make bin
	
override_dh_auto_test:
	go test

override_dh_auto_install:
	install -p -m 0755 $(CURDIR)/bin/vault $(CURDIR)/debian/vault/usr/bin
	install -p -m 0644 $(CURDIR)/debian/vault.png $(CURDIR)/debian/vault/usr/share/pixmaps
	cp -rf $(CURDIR)/debian/etc/* $(CURDIR)/debian/vault/etc/

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

override_dh_dwz:

## vault exporter-0.1.3

=== Makefile ===
.DEFAULT_GOAL := build

GOPATH := $(shell go env | grep GOPATH | sed 's/GOPATH="\(.*\)"/\1/')
PATH := $(GOPATH)/bin:$(PATH)
export $(PATH)

# enable Go 1.11.x module support.
export GO111MODULE=on

BINARY=vault-exporter
VERSION=$(shell git describe --tags --abbrev=0 2>/dev/null | sed -r "s:^v::g")

help:
		@grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-12s\033[0m %s\n", $$1, $$2}'

snapshot: clean fetch ## Generate a snapshot release.
		$(GOPATH)/bin/goreleaser release --snapshot --skip-validate --skip-publish

release: clean fetch ## Generate a release, but don't publish to GitHub.
		$(GOPATH)/bin/goreleaser release --skip-validate --skip-publish

publish: clean fetch ## Generate a release, and publish to GitHub.
		$(GOPATH)/bin/goreleaser release

fetch: ## Fetches the necessary dependencies to build.
		test -f $(GOPATH)/bin/goreleaser || go get -u -v github.com/goreleaser/goreleaser
		go mod download
		go mod tidy
		go mod vendor

clean: ## Cleans up generated files/folders from the build.
		/bin/rm -rfv "dist/" "${BINARY}"

build: fetch clean ## Compile and generate a binary.
		go build -ldflags '-d -s -w' -tags netgo -installsuffix netgo -v -x -o "${BINARY}"

install-tools: install-go install-go-releaser
.PHONY: install-tools

install-go:
	wget -nv -P /tmp https://dl.google.com/go/go$(GO_VERSION).$(OS)-$(ARCH).tar.gz
	tar -C ~/ -xzf /tmp/go$(GO_VERSION).$(OS)-$(ARCH).tar.gz
	rm -r /tmp/go$(GO_VERSION).$(OS)-$(ARCH).tar.gz
.PHONY: install-go

install-goreleaser:
	## Stupid non-standard release format... Linux not linux and x86_64 not amd64.
	wget -nv -P /tmp/ https://github.com/goreleaser/goreleaser/releases/download/v$(GORELEASER_VERSION)/goreleaser_Linux_x86_64.tar.gz
	tar -C ~/bin -xzf /tmp/goreleaser_Linux_x86_64.tar.gz goreleaser
	rm -r /tmp/goreleaser_Linux_x86_64.tar.gz
.PHONY: install-goreleaser

## vault exporter-0.1.3-deps

=== cloud.google.com/go@v0.26.0/firestore/Makefile ===
# Copy textproto files in this directory from the source of truth.

SRC=$(GOPATH)/src/github.com/GoogleCloudPlatform/google-cloud-common/testing/firestore

.PHONY: refresh-tests

refresh-tests:
	-rm genproto/*.pb.go
	cp $(SRC)/genproto/*.pb.go genproto
	-rm testdata/*.textproto
	cp $(SRC)/testdata/*.textproto testdata
	openssl dgst -sha1 $(SRC)/testdata/test-suite.binproto > testdata/VERSION

=== cloud.google.com/go@v0.26.0/internal/readme/Makefile ===
# Rebuild the README.md file at repo root by inserting code samples
# from compilable go files.

SHELL=/bin/bash

GOCLOUD_HOME=$(GOPATH)/src/cloud.google.com/go
README=$(GOCLOUD_HOME)/README.md

.PHONY: readme test test-good test-bad-go test-bad-md

readme:
	@tmp=$$(mktemp); \
	awk -f snipmd.awk snippets.go $(README) > $$tmp; \
	mv $$tmp $(README)

diff:
	diff $(README) <(awk -f snipmd.awk snippets.go $(README))

test: test-good test-bad-go test-bad-md
	@echo PASS

test-good:
	@echo testdata/good.md
	@cd testdata >& /dev/null; \
	diff -u want.md <(awk -f ../snipmd.awk snips.go good.md)
	@echo "testdata/want.md (round trip)"
	@cd testdata >& /dev/null; \
	diff -u want.md <(awk -f ../snipmd.awk snips.go want.md)

test-bad-go:
	@for f in testdata/bad-*.go; do \
	    echo $$f; \
	    if awk -f snipmd.awk $$f >& /dev/null; then \
		echo "$f succeeded, want failure"; \
		exit 1; \
	    fi; \
	done

test-bad-md:
	@for f in testdata/bad-*.md; do \
	    echo $$f; \
	    if awk -f snipmd.awk testdata/snips.go $$f >& /dev/null; then \
		echo "$f succeeded, want failure"; \
		exit 1; \
	    fi; \
	done

=== github.com/gogo/protobuf@v1.2.1/protobuf/Makefile ===
URL="https://raw.githubusercontent.com/google/protobuf/master/src/google/protobuf/"

regenerate:
	go install github.com/gogo/protobuf/protoc-gen-gogotypes
	go install github.com/gogo/protobuf/protoc-min-version

	protoc-min-version \
	--version="3.0.0" \
	--gogotypes_out=../types/ \
	-I=. \
	google/protobuf/any.proto \
	google/protobuf/type.proto \
	google/protobuf/empty.proto \
	google/protobuf/api.proto \
	google/protobuf/timestamp.proto \
	google/protobuf/duration.proto \
	google/protobuf/struct.proto \
	google/protobuf/wrappers.proto \
	google/protobuf/field_mask.proto \
	google/protobuf/source_context.proto

	mv ../types/google/protobuf/*.pb.go ../types/ || true
	rmdir ../types/google/protobuf || true
	rmdir ../types/google || true

update:
	go install github.com/gogo/protobuf/gogoreplace

	(cd ./google/protobuf && rm descriptor.proto; wget ${URL}/descriptor.proto)
	# gogoprotobuf requires users to import gogo.proto which imports descriptor.proto
	# The descriptor.proto is only compatible with proto3 just because of the reserved keyword.
	# We remove it to stay compatible with previous versions of protoc before proto3
	gogoreplace 'reserved 38;' '//reserved 38;' ./google/protobuf/descriptor.proto
	gogoreplace 'reserved 8;' '//reserved 8;' ./google/protobuf/descriptor.proto
	gogoreplace 'reserved 9;' '//reserved 9;' ./google/protobuf/descriptor.proto
	gogoreplace 'reserved 4;' '//reserved 4;' ./google/protobuf/descriptor.proto
	gogoreplace 'reserved 5;' '//reserved 5;' ./google/protobuf/descriptor.proto
	gogoreplace 'option go_package = "github.com/golang/protobuf/protoc-gen-go/descriptor;descriptor";' 'option go_package = "descriptor";' ./google/protobuf/descriptor.proto

	(cd ./google/protobuf/compiler && rm plugin.proto; wget ${URL}/compiler/plugin.proto)
	gogoreplace 'option go_package = "github.com/golang/protobuf/protoc-gen-go/plugin;plugin_go";' 'option go_package = "plugin_go";' ./google/protobuf/compiler/plugin.proto
	
	(cd ./google/protobuf && rm any.proto; wget ${URL}/any.proto)
	gogoreplace 'go_package = "github.com/golang/protobuf/ptypes/any";' 'go_package = "types";' ./google/protobuf/any.proto
	(cd ./google/protobuf && rm empty.proto; wget ${URL}/empty.proto)
	gogoreplace 'go_package = "github.com/golang/protobuf/ptypes/empty";' 'go_package = "types";' ./google/protobuf/empty.proto
	(cd ./google/protobuf && rm timestamp.proto; wget ${URL}/timestamp.proto)
	gogoreplace 'go_package = "github.com/golang/protobuf/ptypes/timestamp";' 'go_package = "types";' ./google/protobuf/timestamp.proto
	(cd ./google/protobuf && rm duration.proto; wget ${URL}/duration.proto)
	gogoreplace 'go_package = "github.com/golang/protobuf/ptypes/duration";' 'go_package = "types";' ./google/protobuf/duration.proto
	(cd ./google/protobuf && rm struct.proto; wget ${URL}/struct.proto)
	gogoreplace 'go_package = "github.com/golang/protobuf/ptypes/struct;structpb";' 'go_package = "types";' ./google/protobuf/struct.proto
	(cd ./google/protobuf && rm wrappers.proto; wget ${URL}/wrappers.proto)
	gogoreplace 'go_package = "github.com/golang/protobuf/ptypes/wrappers";' 'go_package = "types";' ./google/protobuf/wrappers.proto
	(cd ./google/protobuf && rm field_mask.proto; wget ${URL}/field_mask.proto)
	gogoreplace 'option go_package = "google.golang.org/genproto/protobuf/field_mask;field_mask";' 'option go_package = "types";' ./google/protobuf/field_mask.proto
	(cd ./google/protobuf && rm api.proto; wget ${URL}/api.proto)
	gogoreplace 'option go_package = "google.golang.org/genproto/protobuf/api;api";' 'option go_package = "types";' ./google/protobuf/api.proto
	(cd ./google/protobuf && rm type.proto; wget ${URL}/type.proto)
	gogoreplace 'option go_package = "google.golang.org/genproto/protobuf/ptype;ptype";' 'option go_package = "types";' ./google/protobuf/type.proto
	(cd ./google/protobuf && rm source_context.proto; wget ${URL}/source_context.proto)
	gogoreplace 'option go_package = "google.golang.org/genproto/protobuf/source_context;source_context";' 'option go_package = "types";' ./google/protobuf/source_context.proto

=== github.com/gogo/protobuf@v1.2.1/test/issue444/Makefile ===
# Protocol Buffers for Go with Gadgets
#
# Copyright (c) 2018, The GoGo Authors. All rights reserved.
# http://github.com/gogo/protobuf
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

regenerate:
	go install github.com/gogo/protobuf/protoc-min-version
	protoc-min-version --version="3.0.0" --proto_path=\
	.:$(GOPATH)/src/:$(GOPATH)/src/github.com/gogo/protobuf/protobuf/ \
	--gogo_out=. issue444.proto
